//Animatie1.java

import java.awt.Color;
 
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
 
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.Timer;
 
public class Animatie1 extends JPanel implements ActionListener, KeyListener //KeyListener=pt tastatura
{
	Timer tm = new Timer (5, this);  //Timer=pt animatie; pt ActionListener
	int x = 0, y = 0, velX = 0, velY = 0; //x=poz pe orizontala, y=poz pe verticala, velX=viteza pe orizontala, velY=viteza pe verticala  
	
	public Animatie1()
	{
		tm.start();  //pt inceperea procesului de animatie
		addKeyListener(this);
		setFocusable(true); //enable KeyListener
	    setFocusTraversalKeysEnabled(false);
	}
	
	public void paintComponent (Graphics g)
	{
		super.paintComponent(g);
		g.setColor(Color.RED);
		g.fillRect(x, y, 50, 30);	
	}
	
	public void actionPerformed(ActionEvent e)
	{
		//restrictii la spatiul pe care se misca
		if( x < 0 )  //dc obliectul este in stanga, in afara ferestrei
		{
			velX = 0; //oprim viteza
			x = 0;   // repozitionam la 0
		}
		
		if( x > 350 )  //dc obliectul este in dreapta, in afara ferestrei
		{
			velX = 0; //oprim viteza
			x = 350;   // repozitionam la 350
		}
				
		if(y < 0) //dc obliectul este sus, in afara ferestrei
		{
			velY = 0; //oprim viteza
			y = 0;   //repozitionam la 0			
		}
		
		if(y > 250) //dc obliectul este jos, in afara ferestrei
		{
			velY = 0; //oprim viteza
			y = 250;   //repozitionam la 250			
		}
				
		x = x + velX; //creste valoarea lui x cand apasam pe tastatura up sau down
		y = y + velY; //creste valoarea lui y cand apasam pe tastatura up sau down
		repaint();
	}
	
	public void keyPressed(KeyEvent e)    //pt cand apesi down de la tastatura
	{
		int c = e.getKeyCode();         //ia info de la tastatura
		
		if (c == KeyEvent.VK_LEFT)    // CODUL PT SAGEATA STANGA
		{
			velX = -1;   //viteza negativa cand merge in stanga
			velY = 0;	
		}
		
		if (c == KeyEvent.VK_UP)    // CODUL PT SAGEATA SUS
		{
			velX = 0;   //pt ca nu mergem stanga sau dreapta
			velY = -1;	//viteza negativa cand merge in sus
		}
	
		if (c == KeyEvent.VK_RIGHT)    // CODUL PT SAGEATA DREAPTA
		{
			velX = 1;   //viteza pozitiva pt ca merge in dreapta
			velY = 0;	//pt ca nu apasam sus sau jos
		}
				
		if (c == KeyEvent.VK_DOWN)    // CODUL PT SAGEATA 	JOS
		{
			velX = 0;   //pt ca nu apasam dreapta sau stanga
			velY = 1;	//viteza pozitiva pt ca merge in jos
		}	
	}
	
	public void keyTyped(KeyEvent e){}
	public void keyReleased(KeyEvent e) //ca sa nu se mai miste cand dai drumul la buton
	{
		velX = 0;
		velY = 0;
	}
	
	public static void main (String[] args)
	{
		Animatie1 t = new Animatie1();
		JFrame jf = new JFrame();
		jf.setTitle("Animatie1");
		jf.setSize(400, 300);
		jf.setVisible(true);
		jf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		jf.add(t);
	}
}